
/* Header file for some utility functions to process CGI input from
 * Web forms.  Based in part on ideas from Thomas Boutell's book CGI
 * Programming in C & Perl pages 80-88.
 *
 * Written by:
 *	Paul D. Boyle
 *      Box 8204
 *      Department of Chemistry
 *      North Carolina State University
 *      Raleigh, NC 27695-8204
 *
 *      email: boyle@laue.chem.ncsu.edu
 *
 *	July 1997
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *      Terms of License:
 *
 *                          NO WARRANTY
 *
 * 1. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
 * FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
 * OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
 * PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
 * OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK
 * AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
 * PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
 * REPAIR OR CORRECTION.
 * 
 * 2. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
 * WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY
 * AND/OR REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU
 * FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING
 * BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR
 * LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM
 * TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY
 * HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */

#define ENCODED     "application/x-www-form-urlencoded"
#define SPACE_TOKEN '+'
#define FIELD_TOKEN  '&'
#define PAIR_TOKEN   '='
#define ESCAPE_SEQ  '%'
#define SEQ_SIZE     2

#define LINE_FEED    0x0a
#define CARRIAGE_RET 0x0d

/* define a structure for the entered data */
struct cgi_entry {
       char *name;
       char *value;
       };

union cgi_data {
      char *field;
      struct cgi_entry pair;
      };

/* Prototypes */

int VerifyForm( const char *method );  /* returns 0 if ok; != 0 if not */ 
char *ParseNameValuePairs( char *a );
void PlusToSpace( char *a );
char *TranslateEscapes( const char *src );
char *TranslateNewlines( const char *src );
void ReportErrorHTML( const char *a );
int CountFields( char *a );
